#include <vector>
#include "sql.hpp"
#include "values/DnaManager.hpp"
#include "canvas/Canvas.hpp"

enum DrawingStage{
  setup,
  drawTree,
  drawBig,
  done,
};

class Vapp
{
public:
  void init();
  void update();
  void draw();
  void deinit();

private:
  bool showDemoWindow = false;
  bool showSelection = false;
  sqlite3 *db;
  sqlite3_stmt *get_gen_num;
  std::vector<int64_t> ids;
  int64_t gens = -1;
  bool update_gen = false;
  bool enableAll = true;

  int64_t selected_id = -1;
  int selected_gen = -1;
  DnaManagerData manager;
  DrawingStage stageOfDrawing = DrawingStage::done;

  Canvas canvas;
  RenderTexture2D treeTexture;
  int drawTreeIndex = -1;

  RenderTexture2D bigTexture;
  int drawX = 0;
  int drawY = 0;
  void setUpManager();
};